#include <string>
#include <iostream>
#include <vector>
#include <unistd.h>
#include "ace/Synch.h"

class DBHostConfig;
class DBPooledConnection;

class DBPool {

public:

  // R-O
  DBPool(string daemon_user, string daemon_password, string daemon_auth_mode, int initDbConnections, DBHostConfig *host, string id);
  // R-W
  DBPool(string daemon_user, string daemon_password, string daemon_auth_mode, vector<string> users, vector<string> passwords, vector<string>dbs, vector<string> hosts, vector<int>ports,  string id, bool writerTransactionPerRequest=false);
  ~DBPool();
  DBPooledConnection *getPooledConnection(int strategy);
  DBPooledConnection *getConnectionForTest();
  int shrink(int shrinkConns);
  int grow(int growConns);

private:

  unsigned int _npool;
  ACE_Thread_Mutex _used_conn_mutex;
  ACE_Thread_Mutex _tested_conn_mutex;
  unsigned int _used_conn_index;
  unsigned int _tested_conn_index;

  string _daemon_user;
  string _daemon_password;
  string _daemon_auth_mode;
  string _id;

  DBHostConfig * _host;
  unsigned int _nConns;
  vector<DBPooledConnection *> _connections;
  
};

